#pragma once

namespace WindowsInput
{
   struct KEY_INFO
   {
      short key_code;
      char* key_name;
   };

   static KEY_INFO key_info_list[119] = 
   {
      {0,"none"},
      {1,"Left Mouse Button"},
      {2,"Right Mouse Button"},
      {3,"Cancel"},
      {4,"Middle Mouse Button"},
      {5,"X1 Mouse Button"},
      {6,"X2 Mouse Button"},
      {8,"BackSpace"},
      {9,"Tab"},
      {12,"Clear"},
      {13,"Enter"},
      {16,"Shift"},
      {17,"Control"},
      {18,"Alt"},
      {19,"Pause"},
      {20,"Caps Lock"},
      {27,"Escape"},
      {32,"Space Bar"},
      {33,"Page Up"},
      {34,"Page Down"},
      {35,"End"},
      {36,"Home"},
      {37,"Left Arrow"},
      {38,"Up Arrow"},
      {39,"Right Arrow"},
      {40,"Down Arrow"},
      {42,"Print"},
      {44,"Print Screen"},
      {45,"Insert"},
      {46,"Delete"},
      {47,"Help"},
      {48,"0"},
      {49,"1"},
      {50,"2"},
      {51,"3"},
      {52,"4"},
      {53,"5"},
      {54,"6"},
      {55,"7"},
      {56,"8"},
      {57,"9"},
      {65,"A"},
      {66,"B"},
      {67,"C"},
      {68,"D"},
      {69,"E"},
      {70,"F"},
      {71,"G"},
      {72,"H"},
      {73,"I"},
      {74,"J"},
      {75,"K"},
      {76,"L"},
      {77,"M"},
      {78,"N"},
      {79,"O"},
      {80,"P"},
      {81,"Q"},
      {82,"R"},
      {83,"S"},
      {84,"T"},
      {85,"U"},
      {86,"V"},
      {87,"W"},
      {88,"X"},
      {89,"Y"},
      {90,"Z"},
      {96,"NumPad 0"},
      {97,"NumPad 1"},
      {98,"NumPad 2"},
      {99,"NumPad 3"},
      {100,"NumPad 4"},
      {101,"NumPad 5"},
      {102,"NumPad 6"},
      {103,"NumPad 7"},
      {104,"NumPad 8"},
      {105,"NumPad 9"},
      {106,"NumPad *"},
      {107,"NumPad +"},
      {109,"NumPad -"},
      {110,"NumPad ."},
      {111,"NumPad /"},
      {112,"F1"},
      {113,"F2"},
      {114,"F3"},
      {115,"F4"},
      {116,"F5"},
      {117,"F6"},
      {118,"F7"},
      {119,"F8"},
      {120,"F9"},
      {121,"F10"},
      {122,"F11"},
      {123,"F12"},
      {124,"F13"},
      {125,"F14"},
      {126,"F15"},
      {127,"F16"},
      {128,"F17"},
      {129,"F18"},
      {130,"F19"},
      {131,"F20"},
      {132,"F21"},
      {133,"F22"},
      {134,"F23"},
      {135,"F24"},
      {144,"Num Lock"},
      {145,"Scroll Lock"},
      {186,"OEM ;"},
      {187,"OEM ="},
      {188,"OEM ,"},
      {189,"OEM -"},
      {190,"OEM ."},
      {191,"OEM /"},
      {192,"OEM `"},
      {219,"OEM ["},
      {220,"OEM \\"},
      {221,"OEM ]"},
      {222,"OEM '"}
      //{-1,"none"}
   };

   void MarshalString(System::String^ str, char* char_array, int size);
   void MarshalString(System::String^ str, wchar_t* char_array, int size);
   bool IsKeyDown(int keyCode);
   System::String^ Get_Key_Name(short keycode);
   short Get_Key_Code(System::String^ keyname);
}